/***************************************************************************
                          gxvattrview.h  -  description
                             -------------------
    begin                : Thu Jul 25 19:42:22 CEST 2002
    copyright            : (C) 2002 by 
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GXVATTRVIEW_H
#define GXVATTRVIEW_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

// include files for Qt
#include <qwidget.h>

class GxvattrDoc;

/** The GxvattrView class provides the view widget for the GxvattrApp instance.	
 * The View instance inherits QWidget as a base class and represents the view object of a KTMainWindow. As GxvattrView is part of the
 * docuement-view model, it needs a reference to the document object connected with it by the GxvattrApp class to manipulate and display
 * the document structure provided by the GxvattrDoc class.
 * 	
 * @author Source Framework Automatically Generated by KDevelop, (c) The KDevelop Team.
 * @version KDevelop version 0.4 code generation
 */
class GxvattrView : public QWidget
{
  Q_OBJECT
  public:
    /** Constructor for the main view */
    GxvattrView(QWidget *parent = 0, const char *name=0);
    /** Destructor for the main view */
    ~GxvattrView();

    /** returns a pointer to the document connected to the view instance. Mind that this method requires a GxvattrApp instance as a parent
     * widget to get to the window document pointer by calling the GxvattrApp::getDocument() method.
     *
     * @see GxvattrApp#getDocument
     */
    GxvattrDoc *getDocument() const;

    /** contains the implementation for printing functionality */
    void print(QPrinter *pPrinter);
	
  private:
	
};

#endif // GXVATTRVIEW_H
