/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : wto sty 22 22:26:10 CET 2002
    copyright            : (C) 2002 by Piotr Wiejak
    email                : piotr@wiejak.priv.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qapplication.h>
#include <qfont.h>
#include <qstring.h>
#include <qtextcodec.h>
#include <qtranslator.h>
#include <stdlib.h>
#include <unistd.h>

#include "gxvattr.h"
#include "qsliders.h"

#include <X11/Xlib.h>
#include <X11/extensions/Xvlib.h>



int usage()
{

 fprintf(stderr, "usage: gxvattr [-a <adaptor_nr>] [-l] [-h] \n");
exit(0);
return 0;
}


  Display *dpy1;
  char *attr_name1 = NULL;
  uint num_adaptors1 = 0;
  XvAdaptorInfo *adaptor_info1;
  int n1;
  uint adaptor_nr1=0;
  int val1 = -1111111;
  int port_nr1 = -1;
  char line[80];
//  char temps[80];


int getsetmain()
{
    Atom attr_atom;
    attr_atom = XInternAtom(dpy1, attr_name1, False);



    if(port_nr1 == -1) {
      if(num_adaptors1 == 0) {
        fprintf(stderr, "No adaptor found\n");
        exit(-1);
      }
      port_nr1 = adaptor_info1[adaptor_nr1].base_id;
    }
    if(val1 == -1111111) {
      if(XvGetPortAttribute(dpy1, port_nr1, attr_atom, &val1) != Success) {
        fprintf(stderr, "Couldn't get attribute\n");
        exit(-1);
      }
      fprintf(stdout,"%s = %d\n", attr_name1, val1);
    } else {
      if(XvSetPortAttribute(dpy1, port_nr1, attr_atom, val1) != Success) {
        fprintf(stderr, "Couldn't set attribute\n");
        exit(-1);
      }
      XFlush(dpy1);
      fprintf(stdout,"%s set to %d\n", attr_name1, val1);
    }

return 0;
}



void loadme()
{
 FILE *cfg;
  char *cfg_file = NULL;
  char cfg_name[128]="/usr/local/etc/xvattr.conf";
  char *atr,*value;

  dpy1 = XOpenDisplay(NULL);
  if(dpy1 == NULL) {
    fprintf(stderr, "Couldn't open display\n");
    exit(-1);
  }

  XvQueryAdaptors(dpy1, DefaultRootWindow(dpy1),
                  &num_adaptors1, &adaptor_info1);

  if (cfg_file==NULL)
   {
    cfg_file=cfg_name;
   }

  if ((cfg=fopen(cfg_file,"r"))==NULL)
    {
     printf("Error opening file %s!\n",cfg_file);
     exit(1);
    }

    while( (fgets(line,128,cfg))!=NULL)
    {
    if (strlen(line)>4)
      /* Don't read comments */
     if (line[0]!='#')
     {
      atr=strstr(line,"=");
      /* If the line seems to be correct (contains '=') */
      if (atr!=NULL)
       {
       *(atr)='\0';
       attr_name1=line;
       value=atr+1;
       val1=atoi(value);
       /* Apply values (and print it for debugging purposes */
       printf("Setting %s = %i -> ",attr_name1,val1);

			 getsetmain();


       }
     }
    }

  fclose(cfg);

}



int main(int argc, char *argv[])
{

  QApplication a(argc, argv);
  a.setFont(QFont("helvetica", 12));
  QTranslator tor( 0 );
  // set the location where your .qm files are in load() below as the last parameter instead of "."
  // for development, use "/" to use the english original as
  // .qm files are stored in the base project directory.
  tor.load( QString("gxvattr.") + QTextCodec::locale(), "." );
  a.installTranslator( &tor );
  /* uncomment the following line, if you want a Windows 95 look*/
   //a.setStyle(WindowsStyle);


//  GxvattrApp *gxvattr=new GxvattrApp();

int c;
int load=0;
int show=1;
int adap=0;


extern char *optarg;

  while((c = getopt(argc, argv, "a:lh?")) != EOF) {
    switch(c) {
    case 'a':
      adap = atoi(optarg);
      break;
    case 'l':
      load=1;
      loadme();
      show=0;
      exit(1);
      break;
    case 'h':
       show=0;
       usage();
       break;
    case '?':
       show=0;
       usage();
       break;
    default:
      break;
    }
  }


  qsliders *okno=new qsliders();
  a.setMainWidget(okno);

    okno->adaptor=adap;
    okno->load=load;


  if (show)
  {
   okno->show();
   return a.exec();
  }
  else
  {
  return 0;
  }
}


